<template>
  <PageWrapper dense fixedHeight contentFullHeight contentClass="flex">
    <BasicTable
      v-show="!visibleModaDetail"
      @register="registerTable"
      :row-selection="{ selectedRowKeys: selectedKeys, onChange: onSelectChange }"
    >
      <template #toolbar>
        <template v-for="button in tableButtonConfig" :key="button.code">
          <a-button v-if="button.isDefault" type="primary" @click="buttonClick(button.code)">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
          <a-button v-else type="primary">
            <template #icon><Icon :icon="button.icon" /></template>
            {{ button.name }}
          </a-button>
        </template>
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.dataIndex === 'action'">
          <TableAction :actions="getActions(record)" />
        </template>
      </template>
    </BasicTable>

    <LookProcess
      v-if="visibleLookProcessRef"
      :taskId="taskIdRef"
      :processId="processIdRef"
      @close="visibleLookProcessRef = false"
      :visible="visibleLookProcessRef"
    />
    <LaunchProcess
      v-if="visibleLaunchProcessRef"
      :schemaId="schemaIdRef"
      :form-data="formDataRef"
      :form-id="formIdComputedRef"
      @close="handleCloseLaunch"
    />
    <ApprovalProcess
      v-if="visibleApproveProcessRef"
      :taskId="taskIdRef"
      :processId="processIdRef"
      :schemaId="schemaIdRef"
      @close="handleCloseApproval"
      :visible="visibleApproveProcessRef"
    />
    <PrintPreview
      v-if="printData.visible"
      :id="printData.id"
      :request-params-configs="printData.requestParamsConfigs"
      :request-body-configs="printData.requestBodyConfigs"
      :request-header-configs="printData.requestHeaderConfigs"
      @close="printData.visible = false"
    />
    <MesSemiFinishReportModal @register="registerModal" @success="handleSuccess" />

    <!-- 自己写的查看和编辑弹窗 -->
    <a-modal
      :maskClosable="false"
      :title="titleModa"
      v-model:visible="visibleModa"
      :confirm-loading="confirmLoading"
      width="70%"
      :footer="null"
    >
      <propsModal :rowData="rowData" @cancel="handleCancel" @success="handleSuccess"></propsModal>
    </a-modal>
    <div v-if="visibleModaDetail" style="background: #ffffff">
      <div
        style="
          display: flex;
          align-items: center;
          padding-left: 20px;
          padding-top: 10px;
          padding-bottom: 6px;
          border-bottom: 1px solid #dddddd;
        "
      >
        <a-button @click="visibleModaDetail = false">返回</a-button>
        <span style="padding-left: 20px; font-size: 16px; font-weight: 700"
          >半成品检验报告-详情</span
        >
      </div>
      <checkModal
        :rowData="rowData"
        @cancel="visibleModaDetail = false"
        @success="visibleModaDetail = false"
      ></checkModal>
          </div
    >
  </PageWrapper>
</template>
<script lang="ts" setup>
  import { ref, computed, createVNode, reactive } from 'vue';

  import { Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import { BasicTable, useTable, TableAction, ActionItem } from '/@/components/Table';
  import {
    getMesQbSemifinReportPage,
    deleteMesQbSemifinReport,
  } from '/@/api/mes/messemifinishreport';
  import checkModal from '../proorderwork/components/checkModal.vue';
  import { PageWrapper } from '/@/components/Page';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { usePermission } from '/@/hooks/web/usePermission';
  import { useRouter } from 'vue-router';

  import { getPrintConfigInfo } from '/@/api/system/generator/print';
  import PrintPreview from '/@/views/generator/print/Preview.vue';
  import { getMesQbSemifinReport } from '/@/api/mes/messemifinishreport';
  import { PrintButton } from '/@/enums/printEnum';
  import { InputParamItem } from '/@/components/ApiConfig/src/interface';

  import { useModal } from '/@/components/Modal';

  import LookProcess from '/@/views/workflow/task/components/LookProcess.vue';
  import LaunchProcess from '/@/views/workflow/task/components/LaunchProcess.vue';
  import ApprovalProcess from '/@/views/workflow/task/components/ApprovalProcess.vue';
  import { getFormExecuteWorkflow } from '/@/api/form/execute';
  import propsModal from '../messemifinisherror/components/propsModal.vue';
  import MesSemiFinishReportModal from './components/MesSemiFinishReportModal.vue';

  import { searchFormSchema, columns } from './components/config';
  import Icon from '/@/components/Icon/index';

  const { notification } = useMessage();
  const { t } = useI18n();
  defineEmits(['register']);
  const { filterColumnAuth, filterButtonAuth } = usePermission();

  const filterColumns = filterColumnAuth(columns, false);
  //展示在列表内的按钮
  const actionButtons = ref<string[]>(['view', 'edit', 'delete', 'startwork', 'copy', 'addError']);
  const buttonConfigs = computed(() => {
    const list = [
      { isUse: true, code: 'view', icon: 'ant-design:eye-outlined', isDefault: true, name: '查看' },
      { isUse: true, code: 'add', icon: 'ant-design:plus-outlined', isDefault: true, name: '新增' },
      {
        isUse: true,
        code: 'edit',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        name: '编辑',
      },
      {
        isUse: true,
        code: 'delete',
        icon: 'ant-design:delete-outlined',
        isDefault: true,
        name: '删除',
      },
      {
        isUse: true,
        code: 'startwork',
        icon: 'ant-design:form-outlined',
        isDefault: true,
        name: '发起审批',
      },
      {
        isUse: true,
        code: 'copy',
        icon: 'ant-design:copyright-outlined',
        isDefault: true,
        name: '复制',
      },
      {
        isUse: true,
        code: 'addError',
        icon: 'ant-design:plus-outlined',
        isDefault: true,
        name: '异常报告',
      },
    ];
    return filterButtonAuth(list);
  });

  const tableButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => !actionButtons.value.includes(x.code));
  });

  const actionButtonConfig = computed(() => {
    return buttonConfigs.value?.filter((x) => actionButtons.value.includes(x.code));
  });

  const btnEvent = {
    view: handleView,
    add: handleAdd,
    edit: handleEdit,
    delete: handleDelete,
    startwork: handleStartwork,
    copy: handleCopy,
    addError: handleAddError,
  };

  const { currentRoute } = useRouter();
  const printMenuId = computed(() => currentRoute.value.meta.menuId as string);
  const formIdComputedRef = computed(() => currentRoute.value.meta.formId as string);

  const visibleLookProcessRef = ref(false);
  const processIdRef = ref('');

  const visibleLaunchProcessRef = ref(false);
  const schemaIdRef = ref('');
  const formDataRef = ref();

  const visibleApproveProcessRef = ref(false);
  const taskIdRef = ref('');

  const selectedKeys = ref<string[]>([]);
  const selectedRowsData = ref<any[]>([]);

  const [registerModal, { openModal }] = useModal();

  // 模板打印 入参参数
  let printData: {
    visible: boolean;
    id: string;
    code: string;
    requestParamsConfigs: Array<InputParamItem>;
    requestHeaderConfigs: Array<InputParamItem>;
    requestBodyConfigs: Array<InputParamItem>;
  } = reactive({
    visible: false,
    id: '',
    code: '',
    requestParamsConfigs: [],
    requestHeaderConfigs: [],
    requestBodyConfigs: [],
  });

  const [registerTable, { reload }] = useTable({
    title: '半成品检验报告',
    api: getMesQbSemifinReportPage,
    rowKey: 'id',
    columns: filterColumns,
    formConfig: {
      rowProps: {
        gutter: 16,
      },
      schemas: searchFormSchema,
      fieldMapToTime: [
        ['checkDate', ['checkDateStart', 'checkDateEnd'], 'YYYY-MM-DD HH:mm:ss ', true],
        ['createDate', ['createDateStart', 'createDateEnd'], 'YYYY-MM-DD HH:mm:ss ', true],
      ],
    },
    beforeFetch: (params) => {
      return { ...params, FormId: formIdComputedRef.value, PK: 'id' };
    },
    useSearchForm: true,
    showTableSetting: false,
    showLine: true,
    striped: false,
    actionColumn: {
      align: 'left',
      width: 220,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
    },
    customRow,
  });

  function buttonClick(code) {
    if (code.includes(PrintButton.CODE)) {
      printData.code = code;
    }
    btnEvent[code]();
  }
  const titleModa = ref<string>('');
  const visibleModa = ref<boolean>(false);
  const visibleModaDetail = ref<boolean>(false);
  const confirmLoading = ref<boolean>(false);
  const rowData = ref({});
  function handleAddError(record: Recordable) {
    // openModal2(true, {
    //   reportId: record.id,
    //   isUpdate: false,
    // });
    rowData.value = {
      reportId: record.id,
      reportNo: record.reportNo,
      reportName: record.reportName,
      isUpdate: true,
    };

    titleModa.value = '半成品异常报告新增';
    visibleModa.value = true;
  }
  async function handleCancel() {
    visibleModa.value = false;
  }
  function handleCopy(record: Recordable) {
    openModal(true, {
      id: record.id,
      isUpdate: false,
    });
  }
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
    });
  }

  function handleEdit(record: Recordable) {
    openModal(true, {
      id: record.id,
      isUpdate: true,
    });
  }

  function handleDelete(record: Recordable) {
    deleteList([record.id]);
  }

  function deleteList(ids) {
    Modal.confirm({
      title: '提示信息',
      icon: createVNode(ExclamationCircleOutlined),
      content: '是否确认删除？',
      okText: '确认',
      cancelText: '取消',
      onOk() {
        deleteMesQbSemifinReport(ids).then((_) => {
          reload();
          notification.success({
            message: 'Tip',
            description: t('删除成功！'),
          });
        });
      },
      onCancel() {},
    });
  }

  // 模板打印
  async function handleTemplateprint() {
    if (!selectedKeys.value.length) {
      notification.warning({
        message: t('提示'),
        description: t('请选择数据'),
      });
      return;
    }
    if (selectedKeys.value.length > 1) {
      notification.warning({
        message: t('提示'),
        description: t('只能选择一条数据进行操作'),
      });
      return;
    }
    let id = selectedKeys.value[0];
    try {
      const record = await getMesQbSemifinReport(id);
      let res = await getPrintConfigInfo(printData.code, printMenuId.value);
      if (res.enabledMark == null) {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
        return;
      }
      if (res.enabledMark == 0) {
        notification.warning({
          message: t('提示'),
          description: t('找不到打印模板，请联系管理员。'),
        });
        return;
      }
      printData.id = res.schemaId;
      if (res.apiConfig) {
        let json = JSON.parse(res.apiConfig);
        if (json.requestParamsConfigs && json.requestParamsConfigs.length > 0) {
          printData.requestParamsConfigs = json.requestParamsConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestHeaderConfigs && json.requestHeaderConfigs.length > 0) {
          printData.requestHeaderConfigs = json.requestHeaderConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        if (json.requestBodyConfigs && json.requestBodyConfigs.length > 0) {
          printData.requestBodyConfigs = json.requestBodyConfigs.map((ele) => {
            if (ele.config && record[ele.config] != undefined) {
              ele.value = record[ele.config];
            }
            return ele;
          });
        }
        printData.visible = true;
      } else {
        notification.warning({
          message: t('提示'),
          description: t('当前功能未绑定打印模板，请绑定后再进行模板打印。'),
        });
      }
    } catch (error) {}
  }

  function onSelectChange(selectedRowKeys: [], selectedRows) {
    selectedKeys.value = selectedRowKeys;
    selectedRowsData.value = selectedRows;
  }

  function customRow(record: Recordable) {
    return {
      onClick: () => {
        let selectedRowKeys = [...selectedKeys.value];
        if (selectedRowKeys.indexOf(record.id) >= 0) {
          let index = selectedRowKeys.indexOf(record.id);
          selectedRowKeys.splice(index, 1);
        } else {
          selectedRowKeys.push(record.id);
        }
        selectedKeys.value = selectedRowKeys;
      },
    };
  }

  function handleSuccess() {
    handleCancel();
    reload();
  }

  function handleView(record: Recordable) {
    // openModal(true, {
    //   isView: true,
    //   id: record.id,
    // });
    rowData.value = {
      id: record.id,
      reportId: record.id,
      reportName: record.reportName,
      isUpdate: false,
      flag: '半成品',
    };
    visibleModaDetail.value = true;
  }

  function getActions(record: Recordable): ActionItem[] {
    let actionsList: ActionItem[] = [];
    let editAndDelBtn: ActionItem[] = [];
    actionButtonConfig.value?.map((button) => {
      if (button.code === 'view') {
        actionsList.push({
          icon: button?.icon,
          tooltip: button?.name,
          onClick: handleView.bind(null, record),
        });
      }
      if (['edit', 'delete', 'copy', 'addError'].includes(button.code)) {
        editAndDelBtn.push({
          icon: button?.icon,
          tooltip: button?.name,
          color: button.code === 'delete' || button.code === 'addError' ? 'error' : undefined,
          onClick: btnEvent[button.code].bind(null, record),
        });
      }
    });
    if (record.workflowData.enabled) {
      //与工作流有关联的表单
      if (record.workflowData.status) {
        //如果是本人需要审批的数据 就会有taskIds  所以需要修改绑定事件
        const act: ActionItem = {};
        if (record.workflowData.taskIds) {
          act.tooltip = '查看流程(待审批)';
          act.icon = 'daishenpi|svg';
          act.onClick = handleApproveProcess.bind(null, record);
        } else {
          act.tooltip =
            '查看流程' + (record.workflowData.status === 'ACTIVE' ? '(审批中)' : '(已完成)');
          act.icon =
            record.workflowData.status === 'ACTIVE' ? 'jinshenpi|svg' : 'shenpiwancheng|svg';
          act.onClick = handleStartwork.bind(null, record);
        }
        actionsList.unshift(act);
      } else {
        actionsList.unshift({
          icon: 'faqishenpi|svg',
          tooltip: '发起审批',
          onClick: handleLaunchProcess.bind(null, record),
        });
        actionsList = actionsList.concat(editAndDelBtn);
      }
    } else {
      if (!record.workflowData.processId) {
        //与工作流没有关联的表单并且在当前页面新增的数据 如选择编辑、删除按钮则加上
        actionsList = actionsList.concat(editAndDelBtn);
      }
    }
    console.log(actionsList);
    return actionsList.filter((e) => {
      if (e.tooltip == '编辑' || e.tooltip == '删除') {
        if (!record.errorState || record.errorState == '待发起' || record.errorState == '0')
          return true;
        else return false;
      } else if (e.tooltip == '异常报告') {
        if (
          (record.judgeResult == '2' || record.judgeResult == '不合格') &&
          (!record.errorReportId || record.errorReportId.length == 0)
        )
          return true;
        else return false;
      } else return true;
    });
  }

  function handleStartwork(record: Recordable) {
    if (record.workflowData) {
      visibleLookProcessRef.value = true;
      processIdRef.value = record.workflowData.processId;
    }
  }
  async function handleLaunchProcess(record: Recordable) {
    if (record.workflowData) {
      const result = await getFormExecuteWorkflow({
        formId: formIdComputedRef.value,
        id: record['id'],
      });

      visibleLaunchProcessRef.value = true;
      schemaIdRef.value = record.workflowData.schemaId;
      formDataRef.value = result;
    }
  }
  function handleApproveProcess(record: Recordable) {
    visibleApproveProcessRef.value = true;
    schemaIdRef.value = record.workflowData.schemaId;
    processIdRef.value = record.workflowData.processId;
    taskIdRef.value = record.workflowData.taskIds[0];
  }
  function handleCloseLaunch() {
    visibleLaunchProcessRef.value = false;
    reload();
  }
  function handleCloseApproval() {
    visibleApproveProcessRef.value = false;
    reload();
  }
</script>
<style lang="less" scoped>
  :deep(.ant-table-selection-col) {
    width: 50px;
  }
</style>
